# -*- coding: utf-8 -*-
import sys
from urlparse import parse_qsl
import urllib
import requests
import xbmcgui
import xbmcplugin
import xbmcaddon
import xbmc
import inputstreamhelper

base_url = sys.argv[0]
addon_handle = int(sys.argv[1])
params = dict(parse_qsl(sys.argv[2][1:]))
addon = xbmcaddon.Addon(id='plugin.video.pilot.wp')
resources = xbmc.translatePath(addon.getAddonInfo('path') + '/resources/')

limit = 50

main_url = 'https://pilot.wp.pl/api/guest/channels/list'
video_url = 'https://pilot.wp.pl/api/v1/guest/channel/'

headers = {
    'accept': 'application/json',
    'user-agent': 'ExoMedia 4.2.0 (42000) / Android 5.0 / Google Nexus 4 - 5.0.0 - API 21 - 768x1280',
    'accept-encoding': 'gzip'
}


def build_url(query):
    return base_url + '?' + urllib.urlencode(query)


def add_item(name, image, is_folder, is_playble, payload, plot=''):
    list_item = xbmcgui.ListItem(label=name)

    if is_playble:
        list_item.setProperty("IsPlayable", 'true')
    else:
        list_item.setProperty("IsPlayable", 'false')

    list_item.setInfo(type='video', infoLabels={'title': name, 'sorttitle': name, 'plot': plot})
    list_item.setArt({'thumb': image, 'poster': image, 'banner': image})
    xbmcplugin.addDirectoryItem(
        handle=addon_handle,
        url=build_url(payload),
        listitem=list_item,
        isFolder=is_folder
    )


def play():
    id = params.get('id', None)
    data = {'format_id': '2', 'device': 'android-plus'}
    url = video_url + id

    response = requests.get(
        url,
        params=data,
        verify=False,
        headers=headers
    ).json()

    manifest = response.get('data', None).get('stream_channel', None).get('url_base', None)
    play_item = xbmcgui.ListItem(path=manifest)
    xbmcplugin.setResolvedUrl(addon_handle, True, listitem=play_item)


def home():
    data = {'device': 'android-plus'}

    response = requests.get(
        main_url,
        params=data,
        verify=False,
        headers=headers
    ).json()

    items = response.get('channels', None)
    for item in items:
        if item.get('access_status', '') == 'free':
            title = item.get('name', '')
            icon = item.get('thumbnail_mobile', '')
            id = item.get('id', None)
            add_item(title, icon, False, True, {'mode': 'play', 'id': id})

    xbmcplugin.endOfDirectory(addon_handle)


if __name__ == '__main__':
    mode = params.get('mode', None)
    if not mode:
        home()
    elif mode == 'play':
        play()
